#ifndef EA_SOUND
#define EA_SOUND

/* Stuff to use sound the Win95 way - Eric Auer 11.6.2001 */
/* this works similar to the MikMod "drv_w95.c" driver :) */

#include <windows.h>
#include <mmsystem.h>		/* sound stuff */
#include <stdio.h>
#include "w32_exptsppt.h"	/* msec_delay */


// #define EA_SOUND_TIMED
// define to use periodic timer refill
// -> have to implement callback first,
// have a look at drv_w95.c of MikMod for
// an example :-)

#ifdef EA_SOUND_TIMED
#define EAWAVEBUFSIZE 30000
#else
#define EAWAVEBUFSIZE 4000000
#endif
// size is in bytes...

// defaults, should be able to read values from files later!
#define EA_WAVE_CHANNELS 1
#define EA_WAVE_SAMPRATE gIniPara.lWaveFreq
// *** made sampling rate at least configable in .ini 2.7.2001
// *** should better parse RIFF WAVE header for s.r./bits/channels
#define EA_WAVE_BITS 16

static WAVEOUTCAPS myWaveOutCaps;	/* what works and what not */
static HWAVEOUT hWaveOut;			/* handle */
static LPVOID myWaveData;			/* ident to the next: */
static char * myWaveCharData;		/* the wave data itself */
static HGLOBAL hWaveGlobalRAM;		/* handle to global malloced data */
static WAVEHDR myWaveHdr;			/* a WAVE header just like in a file*/

// those return 0 if everything is ok.
// for now, we have neither looping nor timers nor eof-notifiers,
// so the files are loaded completely to RAM before playing

int eaSoundOpen(void);					// checks for sound and opens it
int eaSoundLoadFile(char * filename);	// guess what

int eaSoundPlay(void);					// guess again :-)
long eaSoundWhere(void);				// returns current playing position

void eaSoundUnloadFile(void);			// frees RAM consumed by last file loading
void eaSoundClose(void);					// frees sound device

#endif